"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable prefer-const */
const buffer_1 = require("buffer");
const png_1 = __importDefault(require("./png"));
const webm_1 = __importDefault(require("./webm"));
const gif_1 = __importDefault(require("./gif"));
const fs_1 = require("fs");
let processors = [png_1.default, webm_1.default, gif_1.default];
(() => __awaiter(void 0, void 0, void 0, function* () {
    let files = (0, fs_1.readdirSync)(process.argv[2] || '.');
    for (let file of files) {
        for (let p of processors) {
            if (p.match(file)) {
                const b = (0, fs_1.readFileSync)(file);
                if (!(yield p.has_embed(b, file)))
                    continue;
                let extr = yield p.extract(b, file);
                (0, fs_1.writeFileSync)(`${file}-${extr.filename}`, buffer_1.Buffer.isBuffer(extr.data) ? extr.data : yield extr.data());
            }
        }
    }
}))();
