"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const buffer_1 = require("buffer");
const ebml = __importStar(require("ts-ebml"));
// unused, but will in case 4chan does file sig checks
//const password = Buffer.from("NOA");
const xor = (a, p) => {
    let n = 0;
    for (let i = 0; i < a.byteLength; ++i) {
        a[i] ^= p[n];
        n++;
        n %= p.byteLength;
    }
};
// just some debugging
const printChunks = (chunks, ptr = 0, depth = 0) => {
    if (ptr >= chunks.length)
        return;
    const k = chunks[ptr];
    const closing = ('isEnd' in k && k.isEnd ? 1 : 0);
    console.log('\t'.repeat(depth - closing) + (closing ? '/' : '') + k.name);
    switch (k.type) {
        case "m":
            if (k.isEnd) {
                return printChunks(chunks, ptr + 1, depth - 1);
            }
            else {
                return printChunks(chunks, ptr + 1, depth + 1);
            }
        default:
            return printChunks(chunks, ptr + 1, depth);
    }
};
const findEnclosingTag = (ch, name) => {
    const first = ch.findIndex(e => e.type == 'm' && e.name == name);
    if (first < 0)
        return;
    const second = ch.slice(first).findIndex(e => e.type == 'm' && e.name == name);
    if (second < 0)
        return;
    return [
        first, first + second
    ];
};
const embed = (webm, data) => {
    const dec = new ebml.Decoder();
    const chunks = dec.decode(webm);
    const enc = new ebml.Encoder();
    let embed = chunks.findIndex(e => e.name == "Tracks" && e.type == "m" && e.isEnd);
    const findOrInsert = (n) => {
        let tags = findEnclosingTag(chunks, n);
        const stack = [];
        if (!tags) {
            stack.push({
                type: "m",
                isEnd: false,
                name: n,
                data: buffer_1.Buffer.from('')
            });
            stack.push({
                type: "m",
                isEnd: true,
                name: n,
                data: buffer_1.Buffer.from('')
            });
            chunks.splice(embed + 1, 0, ...stack);
            tags = findEnclosingTag(chunks, n);
        }
        embed = tags[1];
    };
    findOrInsert('Tags');
    findOrInsert('Tag');
    findOrInsert('Targets');
    embed++;
    chunks.splice(embed + 1, 0, ...[
        {
            type: "m",
            isEnd: false,
            name: 'SimpleTag',
            data: buffer_1.Buffer.from('')
        },
        {
            type: "8",
            isEnd: false,
            name: 'TagName',
            data: buffer_1.Buffer.from('COOM')
        },
        {
            type: "8",
            isEnd: false,
            name: 'TagBinary',
            data
        },
        {
            type: "m",
            isEnd: true,
            name: 'SimpleTag',
            data: buffer_1.Buffer.from('')
        }
    ]);
    return buffer_1.Buffer.from(enc.encode(chunks.filter(e => e.name != "unknown")));
};
const extract = (webm) => {
    const dec = new ebml.Decoder();
    const chunks = dec.decode(webm);
    const embed = chunks.findIndex(e => e.name == "TagName" && e.type == '8' && e.value == "COOM");
    const cl = chunks.find(e => e.name == "Cluster");
    if (cl && embed == -1)
        return;
    if (embed == -1)
        return;
    const chk = chunks[embed + 1];
    if (chk.type == "b" && chk.name == "TagBinary")
        return { filename: 'string', data: chk.data };
};
const inject = (container, inj) => __awaiter(void 0, void 0, void 0, function* () { return embed(buffer_1.Buffer.from(yield container.arrayBuffer()), buffer_1.Buffer.from(yield inj.arrayBuffer())); });
const has_embed = (webm) => {
    const dec = new ebml.Decoder();
    const chunks = dec.decode(webm);
    const embed = chunks.findIndex(e => e.name == "TagName" && e.type == '8' && e.value == "COOM");
    const cl = chunks.find(e => e.name == "Cluster");
    if (cl && embed == -1)
        return false; // Tags appear before Cluster, so if we have a Cluster and no coomtag, then it's a definite no
    if (embed == -1) // Found no coomtag, but no cluster, so it might be further
        return;
    return true;
};
exports.default = {
    extract,
    has_embed,
    match: fn => !!fn.match(/\.webm$/)
};
